#include "bug.h"

CProxy_main mainProxy;

void I1::foo1()
{ 
  CkPrintf("**Error** foo1 called\n");
}

void I2::foo2()
{
  CkPrintf("**Error** foo2 called\n");
}

class A : public CBase_A
{
private:

public:
  A() {
	 CkPrintf("[A] created\n");
  }
  virtual void foo1() { 
	 CkPrintf("[A] foo1 called\n");
	 mainProxy.done();
  }
  virtual void foo2() { 
	 CkPrintf("[A] foo2 called\n");
	 mainProxy.done();
  }
};


class main : public Chare
{
private:

public:
  main(CkArgMsg *m) {
	 CkPrintf("[Main] main...\n");
	 CProxy_A a = CProxy_A::ckNew();
	 a.foo2();
	 CkPrintf("[Main] main... done\n");
  }
  void done() {
	 CkPrintf("[Main] All done\n");
	 CkExit();
  }
};



#include "bug.def.h"
